/******************************************************************************
*
* Copyright (C) 2015 -18 Xilinx, Inc.  All rights reserved.
*

******************************************************************************/

/*****************************************************************************/
/**
*
* @file te_xfsbl_hooks.c

******************************************************************************/
/***************************** Include Files *********************************/
//rename to correct board name
#include "te_xfsbl_hooks_te0802.h"
/************************** Constant Definitions *****************************/

/**************************** Type Definitions *******************************/

/***************** Macros (Inline Functions) Definitions *********************/

/************************** Function Prototypes ******************************/

/************************** Variable Definitions *****************************/
u32 TE_XFsbl_HookBeforeBSDownload_Custom(void )
{
	u32 Status = XFSBL_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0802 TE_XFsbl_HookBeforeBSDownload_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

	return Status;
}


u32 TE_XFsbl_HookAfterBSDownload_Custom(void )
{
	u32 Status = XFSBL_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0802 TE_XFsbl_HookAfterBSDownload_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

    return Status;
}

u32 TE_XFsbl_HookBeforeHandoff_Custom(u32 EarlyHandoff)
{
	u32 Status = XFSBL_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0802 TE_XFsbl_HookBeforeHandoff_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

    return Status;
}

/*****************************************************************************/
/**
 * This is a hook function where user can include the functionality to be run
 * before FSBL fallback happens
 *
 * @param none
 *
 * @return error status based on implemented functionality (SUCCESS by default)
 *
  *****************************************************************************/

u32 TE_XFsbl_HookBeforeFallback_Custom(void)
{
	u32 Status = XFSBL_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0802 TE_XFsbl_HookBeforeFallback_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

	return Status;
}

/*****************************************************************************/
/**
 * This function facilitates users to define different variants of psu_init()
 * functions based on different configurations in Vivado. The default call to
 * psu_init() can then be swapped with the alternate variant based on the
 * requirement.
 *
 * @param none
 *
 * @return error status based on implemented functionality (SUCCESS by default)
 *
  *****************************************************************************/

u32 TE_XFsbl_HookPsuInit_custom(void)
{
	u32 Status = XFSBL_SUCCESS;

    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
    xil_printf("TE0802 TE_XFsbl_HookPsuInit_Custom\r\n"); 
	/* Add the code here */
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");

	return Status;
}


/*****************************************************************************/
/**
  * for xsfbl_board.h
  *****************************************************************************/
/*****************************************************************************/
/**
 * This function does board specific initialization.
 * Currently this is done for ZCU102 board.
 * If there isn't any board specific initialization required, it just returns.
 *
 * @param none
 *
 * @return
 * 		- XFSBL_SUCCESS for successful configuration
 * 		- errors as mentioned in xfsbl_error.h
 *
 *****************************************************************************/
u32 TE_XFsbl_BoardInit_Custom(void)
{
	u32 Status = XFSBL_SUCCESS;
  	u32 RegVal = 0;
  
  xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
  xil_printf("TE0802 TE_XFsbl_BoardInit_Custom\r\n");
	/* Add the code here */
	/* Set MIO direction as output */
	XFsbl_Out32(GPIO_DIRM_1,  XFsbl_In32(GPIO_DIRM_1) | RESET_MASK);
	/* Set MIO output enable */
	XFsbl_Out32(GPIO_OEN_1, XFsbl_In32(GPIO_OEN_1) | RESET_MASK);
	/* Set MIO to HIGH */
	RegVal = XFsbl_In32(GPIO_DATA_1) | RESET_MASK;
	XFsbl_Out32(GPIO_DATA_1, RegVal);
	(void)usleep(DELAY_5_US);
	/* Set MIO to LOW */
	RegVal = XFsbl_In32(GPIO_DATA_1) & ~RESET_MASK;
	XFsbl_Out32(GPIO_DATA_1, RegVal);
	(void)usleep(DELAY_5_US);
	/* Set MIO to HIGH */
	RegVal = XFsbl_In32(GPIO_DATA_1) | RESET_MASK;
	XFsbl_Out32(GPIO_DATA_1, RegVal);
	xil_printf("Reset Complete\r\n");
  
  
    xil_printf("\r\n--------------------------------------------------------------------------------\r\n");
  
	return Status;
}
